(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createApp;

var _express = __webpack_require__(1);

var _express2 = _interopRequireDefault(_express);

var _bodyParser = __webpack_require__(2);

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _cors = __webpack_require__(3);

var _cors2 = _interopRequireDefault(_cors);

var _shieldsIoLink = __webpack_require__(4);

var _shieldsIoLink2 = _interopRequireDefault(_shieldsIoLink);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createApp(port, store, badges, templates) {
  const app = (0, _express2.default)();
  app.set('view engine', 'pug');
  app.set('views', templates);
  app.use(_bodyParser2.default.json());
  app.use((0, _cors2.default)());
  app.get('/badges/:badgeType/:project', async (req, res) => {
    const badgeType = req.params.badgeType;
    const project = req.params.project;
    const lastValue = await store.getLast(project, badgeType);
    const badgeHandler = badges[badgeType];
    if (!badgeHandler) {
      return res.status(400).send('wrong badge!');
    }
    const badgeData = badgeHandler.create(lastValue.status);
    const badge = (0, _shieldsIoLink2.default)(badgeData);
    return res.redirect(badge);
  });

  app.get('/badges/:project', async (req, res) => {
    const project = req.params.project;
    const links = await Promise.all(Object.entries(badges).map(async ([badgeType, badgeHandler]) => {
      const lastValue = await store.getLast(project, badgeType);
      // $ExpectError flow thinks that value is mixed type
      const badgeData = badgeHandler.create(lastValue.status);
      return (0, _shieldsIoLink2.default)(badgeData);
    }));
    res.render('projectBadges', {
      project,
      links
    }, (err, html) => {
      if (err) {
        console.error(err);
        return res.send(err);
      }
      return res.send(html);
    });
  });

  app.get('/badges/:badgeType/history/:project', async (req, res) => {
    const project = req.params.project;
    const badgeType = req.params.badgeType;
    const records = await store.getLastN(1000, project, badgeType);
    const timedBadges = records.map(record => {
      const badge = badges[badgeType].create(record.status);
      return {
        link: (0, _shieldsIoLink2.default)(badge),
        time: record.time
      };
    });
    res.render('projectBadgeHistory', {
      project,
      timedBadges
    }, (err, html) => {
      if (err) {
        console.error(err);
        return res.send(err);
      }
      return res.send(html);
    });
  });

  app.post('/badges/:badgeType/:project', async (req, res) => {
    const status = req.body.status;
    const badgeType = req.params.badgeType;
    const project = req.params.project;
    if (typeof status === 'undefined') {
      return res.status(400).send('cant get status from body');
    }

    const badgeHandler = badges[req.params.badgeType];
    await store.store(project, badgeType, status, Date.now());
    if (badgeHandler) {
      const meta = badgeHandler.create(status);
      const badge = (0, _shieldsIoLink2.default)(meta);
      return res.send(badge);
    }
    return res.status(400).json(Object.keys(badges));
  });

  app.get('/status', async (req, res) => {
    try {
      const status = await store.getStatus();
      res.json(status);
    } catch (err) {
      res.status(500).send(err);
    }
  });

  app.get('/status/:badgeType', async (req, res) => {
    try {
      const status = await store.getStatus(undefined, req.params.badgeType);
      res.json(status);
    } catch (err) {
      res.status(500).send(err);
    }
  });
  app.get('/status/projects/:project', async (req, res) => {
    try {
      const status = await store.getStatus(req.params.project, undefined);
      res.json(status);
    } catch (err) {
      res.status(500).send(err);
    }
  });
  app.get('/status/:badgeType/:project', async (req, res) => {
    try {
      const status = await store.getStatus(req.params.project, req.params.badgeType);
      res.json(status);
    } catch (err) {
      res.status(500).send(err);
    }
  });

  app.get('/', (req, res) => {
    res.render('index', {
      badges,
      getLink: _shieldsIoLink2.default
    }, (err, html) => {
      if (err) {
        console.error(err);
        return res.send(err);
      }
      return res.send(html);
    });
  });

  app.listen(port, err => {
    if (err) {
      console.error(err);
      process.exit(1);
    }
    console.log('started');
  });

  return app;
}

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("express");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("body-parser");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("cors");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("shields-io-link");

/***/ })
/******/ ]);
});