(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */,
/* 1 */,
/* 2 */,
/* 3 */,
/* 4 */,
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = testStore;

var _chai = __webpack_require__(6);

var _chai2 = _interopRequireDefault(_chai);

var _chaiAsPromised = __webpack_require__(7);

var _chaiAsPromised2 = _interopRequireDefault(_chaiAsPromised);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_chai2.default.use(_chaiAsPromised2.default);

function testStore(storeCreator, cleanup) {
  describe('#store basic suite', () => {
    beforeEach(function beforeHook() {
      this.context = createStoreForTest(storeCreator, String(Date.now()));
    });
    afterEach(function afterHook() {
      return cleanup(this.context.store);
    });
    describe('#store', () => {
      it('should store status', async function test() {
        const { store, project, subject, status, time } = this.context;
        const result = await store.store(project, subject, status, time);
        (0, _chai.expect)(result).deep.equal({
          status,
          subject
        });
      });
      it('should throw error if no time provided', function test() {
        const { store, project, subject, status } = this.context;
        // $ExpectError
        return (0, _chai.expect)(store.store(project, subject, status)).to.be.rejected;
      });
      it('should throw error if project is not a string', function test() {
        const { store, subject, status, time } = this.context;
        // $ExpectError
        return (0, _chai.expect)(store.store(123, subject, status, time)).to.be.rejected;
      });
      it('should throw error if subject is not a string', function test() {
        const { store, project, status, time } = this.context;
        // $ExpectError
        return (0, _chai.expect)(store.store(project, 123, status, time)).to.be.rejected;
      });
      it('should throw error if status is not a string', function test() {
        const { store, project, subject, time } = this.context;
        // $ExpectError
        return (0, _chai.expect)(store.store(project, subject, 123, time)).to.be.rejected;
      });
      it('should throw error if time is not a number', function test() {
        const { store, project, subject, status, time } = this.context;
        // $ExpectError
        return (0, _chai.expect)(store.store(project, subject, status, String(time))).to.be.rejected;
      });
    });
    describe('#getLast', () => {
      it('should return status and subject same as were provided to store', function test() {
        const { store, project, subject, status, time } = this.context;

        return store.store(project, subject, status, time).then(() => store.getLast(project, subject)).then(res => (0, _chai.expect)(res).to.deep.equal({
          subject,
          status
        }));
      });
      it('should return status and subject same as were provided in last store', function test() {
        const { store, project, subject, status, time } = this.context;

        return store.store(project, subject, status, time).then(() => store.store(project, subject, `${status}-test`, time + 1)).then(() => store.getLast(project, subject)).then(res => (0, _chai.expect)(res).to.deep.equal({
          subject,
          status: `${status}-test`
        }));
      });
      it('should return none status and subject if no records were provided in store before', function test() {
        const { store, project, subject } = this.context;
        return store.getLast(project, subject).then(res => (0, _chai.expect)(res).to.deep.equal({
          subject,
          status: 'none'
        }));
      });
      it('should throw error if no subject provided', function test() {
        const { store, project, subject, status, time } = this.context;
        return (0, _chai.expect)(store.store(project, subject, status, time).then(() =>
        // $ExpectError
        store.getLast(project))).to.be.rejected;
      });
      it('should throw error if no project provided', function test() {
        const { store, project, subject, status, time } = this.context;
        return (0, _chai.expect)(store.store(project, subject, status, time).then(() =>
        // $ExpectError
        store.getLast(null, subject))).to.be.rejected;
      });
      it('should throw error if subject is not a string', function test() {
        const { store, project, subject, status, time } = this.context;

        return (0, _chai.expect)(store.store(project, subject, status, time).then(() =>
        // $ExpectError
        store.getLast(project, 123))).to.be.rejected;
      });
      it('should return status and subject same as were provided in last store for same project/subject', function test() {
        const { store, project, subject, status, time } = this.context;

        return store.store(project, subject, status, time).then(() => store.store(`${project}test`, `${subject}test`, status, time)).then(() => store.getLast(project, subject)).then(res => (0, _chai.expect)(res).to.deep.equal({
          subject,
          status
        }));
      });
    });
    // it does not check count of records/projects/subjects in response
    // because it depends on implementation details
    // For example some stores can store only last datas or
    // store can have additional filter logic in getStatus
    // like globs: proj*
    describe('#getStatus', () => {
      it('should return status', function test() {
        const { store, project, subject, status, time } = this.context;
        return store.store(project, subject, status, time).then(() => store.getStatus()).then(result => {
          (0, _chai.expect)(result).to.have.all.keys(['records', 'projects', 'subjects', 'status']);
        });
      });
      it('should return status by project', function test() {
        const { store, project, subject, status, time } = this.context;
        return store.store(project, subject, status, time).then(() => store.getStatus(project)).then(result => {
          (0, _chai.expect)(result).to.have.all.keys(['records', 'projects', 'subjects', 'status']);
        });
      });
      it('should return status by subject', function test() {
        const { store, project, subject, status, time } = this.context;
        return store.store(project, subject, status, time).then(() => store.getStatus(null, subject)).then(result => {
          (0, _chai.expect)(result).to.have.all.keys(['records', 'projects', 'subjects', 'status']);
        });
      });
      it('should return status by project and status', function test() {
        const { store, project, subject, status, time } = this.context;
        return store.store(project, subject, status, time).then(() => store.getStatus(project, subject)).then(result => {
          (0, _chai.expect)(result).to.have.all.keys(['records', 'projects', 'subjects', 'status']);
        });
      });
      it('should return status even no records were stored', function test() {
        const { store } = this.context;
        return store.getStatus().then(result => {
          (0, _chai.expect)(result).to.have.all.keys(['records', 'projects', 'subjects', 'status']);
        });
      });
    });
  });
}

function createStoreForTest(storeCreator, testname) {
  const store = storeCreator();
  const project = `${testname}-project`;
  const subject = `${testname}-subject`;
  const status = `${testname}-status`;
  const time = Date.now();
  return {
    store,
    project,
    subject,
    status,
    time
  };
}

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("chai");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("chai-as-promised");

/***/ })
/******/ ]);
});